Codeforces Round 886 (Div. 4) E question two-point answer |. picture cardboard

Binary Answer Algorithm Jump Connection

Mircea has n n n pictures. The i i i-th picture is a square with a side length of s i s_i si centimeters.

He mounted each picture on a square piece of cardboard so that each picture has a border of w w w centimeters of cardboard on all sides. In total, he used c c c square centimeters of cardboard. Given the picture sizes and the value c c c, can you find the value of w w w?

A picture of the first test case. Here c = 50 = 5 2 + 4 2 + 3 2 c = 50 = 5^2 + 4^2 + 3^2 c=50=52+42+32, so w = 1 w=1 w=1 is the answer.

Please note that the piece of cardboard goes behind each picture, not just the border.

Input

The first line contains a single integer t t t ( 1 ≤ t ≤ 1000 1 \leq t \leq 1000 1t1000) — the number of test cases.

The first line of each test case contains two positive integers n n n ( 1 ≤ n ≤ 2 ⋅ 1 0 5 1 \leq n \leq 2 \cdot 10^5 1n2105) and c c c ( 1 ≤ c ≤ 1 0 18 1 \leq c \leq 10^{18} 1c1018) — the number of paintings, and the amount of used square centimeters of cardboard.

The second line of each test case contains n n n space-separated integers s i s_i si ( 1 ≤ s i ≤ 1 0 4 1 \leq s_i \leq 10^4 1si104) — the sizes of the paintings.

The sum of n n n over all test cases doesn’t exceed 2 ⋅ 1 0 5 2 \cdot 10^5 2105.

Additional constraint on the input:
Such an integer w w w exists for each test case.

Please note, that some of the input for some test cases won’t fit into 32-bit integer type, so you should use at least 64-bit integer type in your programming language (like long long for C++).

Output

For each test case, output a single integer — the value of w w w (w ≥ 1 w \geq 1w1) which was used to use exactly c c c squared centimeters of cardboard.
Example
input

10
3 50
3 2 1
1 100
6
5 500
2 2 2 2 2
2 365
3 4
2 469077255466389
10000 2023
10 635472106413848880
9181 4243 7777 1859 2017 4397 14 9390 2245 7225
7 176345687772781240
9202 9407 9229 6257 7743 5738 7966
14 865563946464579627
3654 5483 1657 7571 1639 9815 122 9468 3079 2666 5498 4540 7861 5384
19 977162053008871403
9169 9520 9209 9013 9300 9843 9933 9454 9960 9167 9964 9701 9251 9404 9462 9277 9661 9164 9161
18 886531871815571953
2609 10 5098 9591 949 8485 6385 4586 1064 5412 6564 8460 2245 6552 5089 8353 3803 3764

output

1
2
4
5
7654321
126040443
79356352
124321725
113385729
110961227

Note

The first test case is explained in the statement.

For the second test case, the chosen w w w was 2 2 2, thus the only cardboard covers an area of c = ( 2 ⋅ 2 + 6 ) 2 = 1 0 2 = 100 c = (2 \cdot 2 + 6)^2 = 10^2 = 100 c=(22+6)2=102=100 squared centimeters.

For the third test case, the chosen w w w was 4 4 4, which obtains the covered area c = ( 2 ⋅ 4 + 2 ) 2 × 5 = 1 0 2 × 5 = 100 × 5 = 500 c = (2 \cdot 4 + 2)^2 \times 5 = 10^2 \times 5 = 100 \times 5 = 500 c=(24+2)2×5=102×5=100×5=500 squared centimeters.

answer

1. Question meaning

Mircea has n pictures. The i-th piece is a square with side length si cm. He mounted each picture on a square piece of cardboard so that each picture had a w cm cardboard border. In total he used c square centimeters of cardboard. Given the size of the image and the value of c, can you find the value of w? Let these several squares expand the same w outer frame, and finally let the sum of the areas of these frames be the value of c we gave .

2, problem-solving ideas

At a glance, there is no special sorting rule for the data, and there is no obvious mathematical rule in the topic. At this time, we think about the simple algorithm, starting from 1e9 (because the highest long long is 10 18 , so after the square root, it is at most 1e9 ) , and backward Start searching until you find a suitable value and you can stop, but this complexity is O(N 2 ) . Since the answer has an obvious order relationship, we think of binary search at this time to simplify the algorithm and achieve an O(Nlog 2 N) time complexity.

study

Dichotomous answer: Answers are sequential
Explosion of storage space: Once exceeded, pop up

3. Problem-solving code

#include <iostream>
#include <cmath>
using namespace std ;
typedef long long LL ;
const int N = 2e5 + 10 ;
int q[N] ;
LL  n , m ;
 
bool vp(LL x )
{
    
    
	LL sum = 0 ;
	x = x * 2 ;
	for(int i = 0 ; i < n ; i ++ )
	{
    
    
		sum += (x+ q[i])* (x+ q[i]) ; 
		if(sum > m) break; 
		//重点:由于这个和非常大,一旦这个值超出之后就要马上的弹出
	}
 
	if(sum <= m)	return true ;
	else return false ;
}
void bsearch(int q[] ,long long l ,long long r )//二分
{
    
    
	
	while(l < r)
	{
    
    	LL mid = ( r + l + 1 ) >> 1 ;
		if(vp(mid))
		{
    
    
			l = mid ;
		}
		else r = mid - 1 ;
 
	}
	cout << l << endl ; 
}
int main ()
{
    
    
	int t ;
	cin >> t ;
	while ( t -- )
	{
    
    
		
		cin >> n >> m ;
		for(int i = 0 ; i < n ; i ++ )
			cin >> q[i] ;
		bsearch( q , 0 , 1e9 );
 
	}
	
 
	return 0 ;
}

Guess you like

Origin blog.csdn.net/wen030803/article/details/131900048